#!/usr/bin/env python

#Log for Valhalla:
#-ASM   99%
#-Text  99%
#-Hacks 50%
#-GUI   75%

import tkinter as tk
from tkinter import scrolledtext
import tkinter.font as tkFont
from functools import partial
import threading
import fftwlib
import time
import math
import sys
import json
import gc

#Config section
cfgList=[]
cfgFile="../Valhalla.cfg"
icoFile="Valhalla.png"
dicType={"us": 1,
         "eu": 1,
         "jp": 2}
def defCFG():
    global cfgList
    cfgList=[["$-patchFolder:","../Data/patches/"],
             ["$-filesFolder:","files/"],
             ["$-disBOOT:","../Data/boot-dis.txt"],
             ["$-cleanISO:","../Data/fft-wotl.iso"],
             ["$-cleanBOOT:","../Data/boot-decrypted.bin"],
             ["$-cleanPACK:","../Data/fftpack.bin"],
             ["$-modBOOT:","../Data/boot-patched.bin"],
             ["$-modPACK:","../Data/fftpack-patched.bin"],
             ["$-modISO:","../Data/fft-wotl-patched.iso"],
             ["$-logFile:","../Data/Valhalla.log"],
             ["$-fontSize:",["disable",14,12]],
             ["$-windSize:","640x360"],
             ["$-type:","us"],
             ["$-bkl:","blacklist.asm"],
             ["$-patches:",[["default-core-hacks.asm","enable"],
                           ["default-text-hacks.asm","enable"],
                           ["default-data-hacks.asm","enable"],
                           ["default-cust-hacks.asm","enable"],
                           ["default-expe-hacks.asm","disable"]],
                          [["jp-default-core-hacks.asm","enable"],
                           ["jp-default-text-hacks.asm","enable"],
                           ["jp-default-data-hacks.asm","enable"],
                           ["jp-default-cust-hacks.asm","enable"]]],
             ["$-DPFont:",False,False],
             ["$-tFiles:",[["spell-mes","enable",[[0]],0],
                          ["snpl-mes","enable",[[1,2,3,4]],40960],
                          ["wld-mes","enable",[[0]],32768],
                          ["tuto-mes","enable",[[-1],[0],[0],[0],[0],[0],[0],[0]],0],
                          ["rest-mes","enable",[[0],[0],[1]],0,[3267456,2758192,3305252]],
                          ["test-evt","enable",[[0]]]],
                         [["spell-mes","disable",[[0]],0],
                          ["snpl-mes","disable",[[0]],40960],
                          ["wld-mes","enable",[[0]],32768],
                          ["tuto-mes","enable",[[-1],[0],[0],[0],[0],[0],[0],[0]],0],
                          ["rest-mes","disable",[[0]],0,[0,0,0]],
                          ["test-evt","enable",[[0]]]]],
             ["$-dTFiles:",[["0.MES"],
                           ["0.BIN"],
                           ["0.BIN"],
                           ["0.MES","1.MES","2.MES","3.MES",
                            "4.MES","5.MES","6.MES","7.MES"],
                           ["0.BIN","1.BIN","2.BIN"],
                           ["TEST.EVT"]],
                          [[],
                           [],
                           ["0.BIN"],
                           ["0.MES","1.MES","2.MES","3.MES",
                            "4.MES","5.MES","6.MES","7.MES"],
                           [],
                           ["TEST.EVT"]]],
             ["$-eTFiles:",[[["INDEXED",172]],
                           [["INDEXED",3100]],
                           [["INDEXED",3092]],
                           [["INDEXED",-1],["INDEXED",3028],["INDEXED",3036],
                            ["INDEXED",3044],["INDEXED",3052],["INDEXED",3060],
                            ["INDEXED",3068],["INDEXED",3076]],
                           [["BOOT",3267456,1428],["BOOT",2758192,220264],
                            ["BOOT",3305252,209824]],
                           [["INDEXED",92]]],
                          [[],
                           [],
                           [["INDEXED",3092]],
                           [["INDEXED",-1],["INDEXED",3028],["INDEXED",3036],
                            ["INDEXED",3044],["INDEXED",3052],["INDEXED",3060],
                            ["INDEXED",3068],["INDEXED",3076]],
                           [],
                           [["INDEXED",92]]]]]
    return
def testCFG():
    if ((next((x for x in cfgList if x[0]=="$-patchFolder:"),None)==None)
            or (next((x for x in cfgList if x[0]=="$-filesFolder:"),None)==None)
            or (next((x for x in cfgList if x[0]=="$-disBOOT:"),None)==None)
            or (next((x for x in cfgList if x[0]=="$-cleanISO:"),None)==None)
            or (next((x for x in cfgList if x[0]=="$-cleanBOOT:"),None)==None)
            or (next((x for x in cfgList if x[0]=="$-cleanPACK:"),None)==None)
            or (next((x for x in cfgList if x[0]=="$-modBOOT:"),None)==None)
            or (next((x for x in cfgList if x[0]=="$-modPACK:"),None)==None)
            or (next((x for x in cfgList if x[0]=="$-modISO:"),None)==None)
            or (next((x for x in cfgList if x[0]=="$-logFile:"),None)==None)
            or (next((x for x in cfgList if x[0]=="$-fontSize:"),None)==None)
            or (next((x for x in cfgList if x[0]=="$-windSize:"),None)==None)
            or (next((x for x in cfgList if x[0]=="$-type:"),None)==None)
            or (next((x for x in cfgList if x[0]=="$-bkl:"),None)==None)
            or (next((x for x in cfgList if x[0]=="$-patches:"),None)==None)
            or (next((x for x in cfgList if x[0]=="$-DPFont:"),None)==None)
            or (next((x for x in cfgList if x[0]=="$-tFiles:"),None)==None)
            or (next((x for x in cfgList if x[0]=="$-dTFiles:"),None)==None)
            or (next((x for x in cfgList if x[0]=="$-eTFiles:"),None)==None)):
        raise
    return
#End of config section

#Text section
appName="Valhalla 0.87"
bText=["Setup files",
       "Decode text files",
       "Encode text files",
       "Decode EVT",
       "Encode EVT",
       "Apply patches",
       "EDD EBOOT",
       "Clear Log",
       "Save Log",
       "Reload CFG",
       "Save CFG"]
okMsg="Successfully saved."
okMsg2=" seconds"
errMsg="Unknown command."
errMsg2="Bad CFG. Default configuration loaded."
errMsg3="Bad CFG. Configuration file loaded."
#End text section

def execFunction(num):
    try:
        start_time=time.time()
        type=dicType.get(next((x[1] for x in cfgList if x[0]=="$-type:"),1))
        filesFolder=next((x[1] for x in cfgList if x[0]=="$-patchFolder:"),"")
        filesFolder+=next((x[1] for x in cfgList if x[0]=="$-filesFolder:"),"")
        if num==0:
            fftwlib.setReq(filesFolder,
                           next((x[type] for x in cfgList if x[0]=="$-tFiles:"),None),
                           next((x[type] for x in cfgList if x[0]=="$-dTFiles:"),None),
                           next((x[type] for x in cfgList if x[0]=="$-eTFiles:"),None),
                           next((x[1] for x in cfgList if x[0]=="$-cleanISO:"),None),
                           next((x[1] for x in cfgList if x[0]=="$-cleanPACK:"),None),
                           next((x[1] for x in cfgList if x[0]=="$-cleanBOOT:"),None),
                           next((x[1] for x in cfgList if x[0]=="$-modBOOT:"),None),
                           next((x[1] for x in cfgList if x[0]=="$-modPACK:"),None),
                           next((x[1] for x in cfgList if x[0]=="$-modISO:"),None))
        elif num==1:
            fftwlib.deTFiles(filesFolder,
                             next((x[type][:-1] for x in cfgList if x[0]=="$-tFiles:"),None),
                             next((x[type][:-1] for x in cfgList if x[0]=="$-dTFiles:"),None),
                             next((x[type] for x in cfgList if x[0]=="$-DPFont:"),None))
        elif num==2:
            fftwlib.enTFiles(filesFolder,
                             next((x[type][:-1] for x in cfgList if x[0]=="$-tFiles:"),None))
        elif num==3:
            fftwlib.deEVT(filesFolder,
                          next((x[type][-1] for x in cfgList if x[0]=="$-tFiles:"),None),
                          next((x[type][-1] for x in cfgList if x[0]=="$-dTFiles:"),None),
                          next((x[type] for x in cfgList if x[0]=="$-DPFont:"),None),
                          type-1)
        elif num==4:
            fftwlib.enEVT(filesFolder,
                          next((x[type][-1] for x in cfgList if x[0]=="$-tFiles:"),None),
                          type-1)
        elif num==5:
            fftwlib.appPatch(next((x[1] for x in cfgList if x[0]=="$-patchFolder:"),None),
                             next((x[1] for x in cfgList if x[0]=="$-bkl:"),None),
                             next((x[type] for x in cfgList if x[0]=="$-patches:"),None),
                             next((x[1] for x in cfgList if x[0]=="$-modBOOT:"),None),
                             next((x[1] for x in cfgList if x[0]=="$-modPACK:"),None),
                             next((x[1] for x in cfgList if x[0]=="$-modISO:"),None))
        elif num==6:
            fftwlib.exDeDisEBOOT(next((x[1] for x in cfgList if x[0]=="$-cleanISO:"),None),
                                 next((x[1] for x in cfgList if x[0]=="$-cleanBOOT:"),None),
                                 next((x[1] for x in cfgList if x[0]=="$-disBOOT:"),None))
        else:
            print(errMsg)
        print("--- "+"{:.2f}".format(time.time()-start_time)+okMsg2+" ---")
    except Exception as e:
        print(e)
    gc.collect()
    return

class StdRedirector(object):
    def __init__(self,text_widget):
        self.text_space=text_widget

    def write(self,string):
        self.text_space.insert(tk.END,string)
        self.text_space.see(tk.END)

    def flush(self):
        return

class ValhallaGUI(tk.Tk):
    def __init__(self,*args,**kwargs):
        tk.Tk.__init__(self,*args,**kwargs)
        self.InitUI()

    def InitUI(self):
        self.tk.call("wm","iconphoto",self._w,tk.PhotoImage(file=icoFile))
        self.title(appName)
        global cfgList
        try:
            with open(cfgFile,encoding="utf8",errors="ignore") as file:
                cfgList=json.load(file)
            testCFG()
        except:
            defCFG()
        self.geometry(next((x[1] for x in cfgList if x[0]=="$-windSize:"),"160x90"))
        self.minsize(width=160,height=90)
        self.matrixSize=180
        for i in range(0,self.matrixSize):
            self.columnconfigure(i,weight=1,uniform="fred")
            self.rowconfigure(i,weight=1,uniform="fred")
        self.bFont=tkFont.Font()
        self.tFont=tkFont.Font()
        self.vBackgroundProcess=[]
        self.runningProcess=False
        self.bind("<Configure>",self.resizer)
        self.butt=[]
        rowDivB=math.floor(self.matrixSize/(7+2))
        colDivB=math.floor(0.15*self.matrixSize)
        rowDivT=self.matrixSize
        colDivT=math.floor(0.7*self.matrixSize)
        currRow,currCol,bIndex=0,0,7
        for i in range(0,bIndex):
            self.butt.append(tk.Button(self,text=bText[i],font=self.bFont,width=1,
                                       height=1,command=partial(self.on_button,i),
                                       bg="pale green" if (i==0 or i==6) else ("gold" if i!=5  else "tomato")))
            self.butt[i].grid(column=currCol,row=currRow,rowspan=rowDivB,columnspan=2*colDivB,sticky="nesw")
            currRow+=rowDivB
            self.bind("<F"+str(i+1)+">",partial(self.on_button,i))
        currCol=0
        self.bind("<Control-s>",self.saveCFG)
        self.butt.append(tk.Button(self,text=bText[bIndex],font=self.bFont,width=1,
                              height=1,command=self.clearText,bg="sky blue"))
        self.butt[bIndex].grid(column=currCol,row=currRow,rowspan=rowDivB,columnspan=colDivB,sticky="nesw")
        currCol+=colDivB
        bIndex+=1
        self.bind("<F8>",self.clearText)
        self.butt.append(tk.Button(self,text=bText[bIndex],font=self.bFont,width=1,
                              height=1,command=self.saveText,bg="sky blue"))
        self.butt[bIndex].grid(column=currCol,row=currRow,rowspan=rowDivB,columnspan=colDivB,sticky="nesw")
        currRow+=rowDivB
        bIndex+=1
        self.bind("<F9>",self.saveText)
        currCol=0
        self.butt.append(tk.Button(self,text=bText[bIndex],font=self.bFont,width=1,
                                   height=1,command=self.loadCFG,bg="sky blue"))
        self.butt[bIndex].grid(column=currCol,row=currRow,rowspan=rowDivB,columnspan=colDivB,sticky="nesw")
        currCol+=colDivB
        bIndex+=1
        self.bind("<Control-d>",self.loadCFG)
        self.butt.append(tk.Button(self,text=bText[bIndex],font=self.bFont,width=1,
                              height=1,command=self.saveCFG,bg="sky blue"))
        self.butt[bIndex].grid(column=currCol,row=currRow,rowspan=rowDivB,columnspan=colDivB,sticky="nesw")
        currCol+=colDivB
        currRow=0
        self.text_box=scrolledtext.ScrolledText(self,font=self.tFont,wrap="word",width=1,height=1,bg="black",fg="white")
        self.text_box.grid(column=currCol,row=currRow,rowspan=rowDivT,columnspan=colDivT,sticky="nesw")
        sys.stdout=StdRedirector(self.text_box)
        sys.stderr=StdRedirector(self.text_box)
        self.clearText()

    def resizer(self,event=None):
        fSet=next((x[1] for x in cfgList if x[0]=="$-fontSize:"),None)
        if fSet[0]=="disable":
            wm,hm=self._root().winfo_width(),self._root().winfo_height()
            self.bFont.configure(size=min(math.floor((wm-160)/80)+4,math.floor((hm-90)/45)+4))
            self.tFont.configure(size=min(math.floor((wm-160)/80)+8,math.floor((hm-90)/45)+8))
        else:
            self.bFont.configure(size=fSet[1])
            self.tFont.configure(size=fSet[2])

    def loadCFG(self,event=None):
        global cfgList
        self.clearText()
        outMsg=""
        try:
            with open(cfgFile,encoding="utf8",errors="ignore") as file:
                cfgList=json.load(file)
            testCFG()
        except:
            outMsg=errMsg2
            defCFG()
        finally:
            self.text_box.insert(1.0,json.dumps(cfgList,indent=4,sort_keys=True))
            return outMsg

    def saveCFG(self,event=None):
        global cfgList
        outMsg=okMsg
        try:
            cfgList=json.loads(self.text_box.get(1.0,tk.END)[:-1])
            testCFG()
        except:
            outMsg=errMsg3
            tmpMsg=self.loadCFG()
            if tmpMsg:
                outMsg=tmpMsg
        finally:
            self.resizer()
            self.clearText()
            print(outMsg)
            with open(cfgFile,"w",encoding="utf8",errors="ignore") as file:
                file.writelines(json.dumps(cfgList,indent=4,sort_keys=True))

    def clearText(self,event=None):
        self.text_box.delete(1.0,tk.END)

    def saveText(self,event=None):
        with open(next((x[1] for x in cfgList if x[0]=="$-logFile:"),None),
                  "w",encoding="utf8",errors="ignore") as file:
            file.writelines(self.text_box.get(1.0,tk.END))

    def on_button(self,num,event=None):
        if not self.runningProcess:
            self.runningProcess=True
            self.vBackgroundProcess=threading.Thread(target=partial(self.threaded_task,num))
            self.vBackgroundProcess.daemon=True
            self.vBackgroundProcess.start()

    def set_buttons_state(self,enable=True):
        state="normal" if enable else "disable"
        for i in range(0,len(self.butt)):
            self.butt[i]["state"]=state

    def threaded_task(self,num):
        self.set_buttons_state(False)
        execFunction(num)
        self.runningProcess=False
        self.set_buttons_state(True)

if __name__=="__main__":
    ValhallaGUI().mainloop()
