#!/usr/bin/env python

import ctypes
import os

def kirk_SGN(elf,tag,folder):
    try:
        libName=folder+"libkirk.so"
        if os.name=="nt":
            libName=folder+"libkirk.dll"
        _file=libName
        _path=os.path.join(*(os.path.split(__file__)[:-1]+(_file,)))
        _mod=ctypes.cdll.LoadLibrary(_path)
        _kirk_SGN=_mod.sign_eboot
        _kirk_SGN.argtypes=(ctypes.c_char_p,ctypes.c_int,ctypes.c_int,ctypes.c_char_p)
        _kirk_SGN.restype=ctypes.c_int
        bin=b'\x00'*(len(elf)+4096)
        bin=ctypes.create_string_buffer(bin)
        value=_kirk_SGN(ctypes.create_string_buffer(elf),len(elf),tag,bin)
        return value,bin
    except:
        return -1,elf

def sign(fin,fou,tag,libFolder):
    with open(fin,mode="rb") as file:
        elf=file.read()
    value,bin=kirk_SGN(elf,tag,libFolder)
    if value>0:
        print("Resigned boot.bin")
        with open(fou,mode="wb") as file:
            file.write(bin[:value])
        return fou
    else:
        print("Fail to resign boot.bin")
    return fin
