#!/usr/bin/env python

import ctypes
import os

def kirk_DEC(bin,folder):
    try:
        libName=folder+"libkirk.so"
        if os.name=="nt":
            libName=folder+"libkirk.dll"
        _file=libName
        _path=os.path.join(*(os.path.split(__file__)[:-1]+(_file,)))
        _mod=ctypes.cdll.LoadLibrary(_path)
        _kirk_DEC=_mod.decrypt_eboot
        _kirk_DEC.argtypes=(ctypes.c_char_p,ctypes.c_char_p)
        _kirk_DEC.restype=ctypes.c_int
        outBin=b"\x00"*(len(bin))
        outBin=ctypes.create_string_buffer(outBin)
        value=_kirk_DEC(ctypes.create_string_buffer(bin),outBin)
        return value,outBin
    except:
        return -1,bin
def decrypt(fin,fou,libFolder):
    with open(fin,mode="rb") as file:
        bin=file.read()
    value,bin=kirk_DEC(bin,libFolder)
    if value>0:
        print(" Done.")
        with open(fou,mode="wb") as file:
            file.write(bin[:value])
    else:
        print(" Fail to decrypt EBOOT.BIN")
        print("Dumping raw:")
        with open(fou,"wb") as ofile:
            with open(fin,"rb") as file:
                ofile.write(file.read())
        print(" Done.")
    return
