#!/usr/bin/env python

EVTCommandSize=[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,15,
                6,3,3,3,1,1,6,7,17,6,15,2,1,1,6,7,3,
                4,4,1,5,3,1,9,3,1,1,8,7,9,5,1,6,8,
                6,3,5,3,3,3,1,1,13,3,3,10,5,6,5,1,2,
                3,4,3,9,1,1,1,1,3,2,4,2,2,6,3,8,3,
                3,1,1,4,2,2,2,4,2,2,7,3,4,7,2,3,1,
                1,3,4,9,6,6,3,3,13,3,5,3,1,15,7,7,7,
                1,3,5,3,3,1,2,5,5,4,4,1,6,2,2,4,5,
                1,1,1,1,7,1,1,2,4,4,6,3,3,1,1,3,3,
                3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
                1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,
                5,5,5,3,2,17,6,3,3,6,3,7,1,1,1,1,1,
                1,1,1,5,2,2,2,2,2,2,1,1,2,2,1,1,1,
                1,1,1,3,2,2,1,2,3,1,1,1,1,1,1,1,1,
                1,1,1,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1]

EVTNa2Va={
    "DisplayMessage": [16,"<BBHBBBhhhB"],
    "UnitAnim": [17,"<BBHB"],
    "EVTC_18": [18,"<BB"],
    "ChangeMapBeta": [19,"<BB"],
    "EVTC_20": [20,""],
    "EVTC_21": [21,""],
    "Pause": [22,""],
    "EVTC_23": [23,"<BBBBB"],
    "Effect": [24,"<HBBBB"],
    "Camera": [25,"<hhhhhhhh"],
    "MapDarkness": [26,"<BbbbB"],
    "MapLight": [27,"<hhhhhhh"],
    "EventSpeed": [28,"<B"],
    "CameraFusionStart": [29,""],
    "CameraFusionEnd": [30,""],
    "Focus":[31,"<BBBBB"],
    "EVTC_32": [32,""],
    "Sound": [33,"<H"],
    "Music": [34,"<BbB"],
    "EVTC_35": [35,"<BBBB"],
    "EVTC_36": [36,""],
    "EVTC_37": [37,"<BBBB"],
    "EVTC_38": [38,"<BB"],
    "ReloadMapState": [39,""],
    "WalkTo": [40,"<BBBBBBbB"],
    "WaitWalk": [41,"<BB"],
    "BlockStart": [42,""],
    "BlockEnd": [43,""],
    "FaceUnit2": [44,"<BBBBBBB"],
    "RotateUnit": [45,"<BBBBBB"],
    "Background": [46,"<BBBBBBBB"],
    "EVTC_47": [47,""],
    "EVTC_48": [48,"<B"],
    "ColorBGBeta": [49,"<BbbbB"],
    "ColorUnit": [50,"<BBBbbbB"],
    "ColorField": [51,"<BbbbB"],
    "EVTC_52": [52,""],
    "EVTC_53": [53,""],
    "EVTC_54": [54,""],
    "EVTC_55": [55,"<BB"],
    "FocusSpeed": [56,"<h"],
    "EVTC_57": [57,""],
    "EVTC_58": [58,""],
    "SpriteMove": [59,"<BBhhhBBh"],
    "Weather": [60,"<BB"],
    "RemoveUnit": [61,"<BB"],
    "ColorScreen": [62,"<BBBBBBBh"],
    "EVTC_63": [63,"<BBBB"],
    "EVTC_64": [64,"<BBBBB"],
    "EarthquakeStart": [65,"<BBBB"],
    "EarthquakeEnd": [66,""],
    "CallFunction": [67,"<B"],
    "Draw": [68,"<BB"],
    "AddUnit": [69,"<BBB"],
    "Erase": [70,"<BB"],
    "AddGhostUnit": [71,"<BBBBBBBB"],
    "WaitAddUnit": [72,""],
    "AddUnitStart": [73,""],
    "AddUnitEnd": [74,""],
    "WaitAddUnitEnd": [75,""],
    "ChangeMap": [76,"<BB"],
    "Reveal": [77,"<B"],
    "UnitShadow": [78,"<BBB"],
    "SetDaytime": [79,"<B"],
    "PortraitCol": [80,"<B"],
    "ChangeDialog": [81,"<BHBB"],
    "EVTC_82": [82,""],
    "FaceUnit": [83,"<BBBBBBB"],
    "Use3DObject": [84,"<BB"],
    "UseFieldObject": [85,"<BB"],
    "Wait3DObject": [86,""],
    "WaitFieldObject": [87,""],
    "LoadEVTCHR": [88,"<BBB"],
    "SaveEVTCHR": [89,"<B"],
    "SaveEVTCHRClear": [90,"<B"],
    "LoadEVTCHRClear": [91,"<B"],
    "EVTC_92": [92,"<BBB"],
    "EVTC_93": [93,"<B"],
    "EndSong": [94,"<B"],
    "WarpUnit": [95,"<BBBBBB"],
    "FadeSound": [96,"<BB"],
    "EVTC_97": [97,"<BBB"],
    "EVTC_98": [98,"<BBBBBB"],
    "EVTC_99": [99,"<B"],
    "WaitRotateUnit": [100,"<BB"],
    "WaitRotateAll": [101,""],
    "EVTC_102": [102,""],
    "EVTC_103": [103,""],
    "MirrorSprite": [104,"<BBB"],
    "FaceTile": [105,"<BBBBBBBB"],
    "EditBGSound": [106,"<BbbBB"],
    "BgSound": [107,"<BbbbB"],
    "EVTC_108": [108,"<BB"],
    "EVTC_109": [109,"<BB"],
    "SpriteMoveBeta": [110,"<BBhhhBBH"],
    "WaitSpriteMove": [111,"<BB"],
    "Jump": [112,"<BBBB"],
    "EVTC_113": [113,"<BB"],
    "EVTC_114": [114,""],
    "EVTC_115": [115,"<BBBBBBBBBBBBBB"],
    "EVTC_116": [116,"<BBBBBB"],
    "EVTC_117": [117,"<BBBBBB"],
    "DarkScreen": [118,"<BBBBBB"],
    "RemoveDarkScreen": [119,""],
    "DisplayConditions": [120,"<BB"],
    "WalkToAnim": [121,"<BBH"],
    "DismissUnit": [122,"<BB"],
    "EVTC_123": [123,"<BB"],
    "EVTC_124": [124,""],
    "ShowGraphic": [125,"<B"],
    "WaitValue": [126,"<HH"],
    "EVTCHRPalette": [127,"<BBBB"],
    "March": [128,"<BBB"],
    "EVTC_129": [129,"<BBB"],
    "EVTC_130": [130,""],
    "ChangeStats": [131,"<BBBh"],
    "PlaySong": [132,"<B"],
    "UnlockDate": [133,"<B"],
    "TempWeapon": [134,"<BBB"],
    "Arrow": [135,"<BBBB"],
    "MapUnfreeze": [136,""],
    "MapFreeze": [137,""],
    "EffectStart": [138,""],
    "EffectEnd": [139,""],
    "UnitAnimRotate": [140,"<BBBHB"],
    "EVTC_141": [141,""],
    "WaitGraphicPrint": [142,""],
    "EVTC_143": [143,"<B"],
    "EVTC_144": [144,"<BBB"],
    "ShowMapTitle": [145,"<bbb"],
    "InflictStatus": [146,"<BBBBB"],
    "EVTC_147": [147,"<BB"],
    "TeleportOut": [148,"<BB"],
    "EVTC_149": [149,""],
    "AppendMapState": [150,""],
    "ResetPalette": [151,"<BB"],
    "TeleportIn": [152,"<BB"],
    "BlueRemoveUnit": [153,"<BB"],
    "EVTC_154": [154,""],
    "EVTC_155": [155,""],
    "EVTC_156": [156,""],
    "EVTC_157": [157,""],
    "EVTC_158": [158,""],
    "EVTC_159": [159,""],
    "LTE": [160,""],
    "GTE": [161,""],
    "EQ": [162,""],
    "NEQ": [163,""],
    "LT": [164,""],
    "GT": [165,""],
    "EVTC_166": [166,""],
    "EVTC_167": [167,""],
    "EVTC_168": [168,""],
    "EVTC_169": [169,""],
    "EVTC_170": [170,""],
    "EVTC_171": [171,""],
    "EVTC_172": [172,""],
    "EVTC_173": [173,""],
    "EVTC_174": [174,""],
    "EVTC_175": [175,""],
    "ADD": [176,"<HH"],
    "ADDVar": [177,"<HH"],
    "SUB": [178,"<HH"],
    "SUBVar": [179,"<HH"],
    "MULT": [180,"<HH"],
    "MULTVar": [181,"<HH"],
    "DIV": [182,"<HH"],
    "DIVVar": [183,"<HH"],
    "DIVHI": [184,"<HH"],
    "DIVHIVar": [185,"<HH"],
    "AND": [186,"<HH"],
    "ANDVar": [187,"<HH"],
    "OR": [188,"<HH"],
    "ORVar": [189,"<HH"],
    "ZERO": [190,"<H"],
    "EVTC_191": [191,""],
    "EVTC_192": [192,""],
    "EVTC_193": [193,""],
    "EVTC_194": [194,""],
    "EVTC_195": [195,""],
    "EVTC_196": [196,""],
    "EVTC_197": [197,""],
    "EVTC_198": [198,""],
    "EVTC_199": [199,""],
    "EVTC_200": [200,""],
    "EVTC_201": [201,""],
    "EVTC_202": [202,""],
    "EVTC_203": [203,""],
    "EVTC_204": [204,""],
    "EVTC_205": [205,""],
    "EVTC_206": [206,""],
    "EVTC_207": [207,""],
    "JumpForwardIfNot": [208,"<B"],
    "JumpForward": [209,"<B"],
    "ForwardTarget": [210,"<B"],
    "JumpBack": [211,"<B"],
    "EVTC_212": [212,"<B"],
    "BackTarget": [213,"<B"],
    "EVTC_214": [214,""],
    "EVTC_215": [215,""],
    "EVTC_216": [216,"<B"],
    "EVTC_217": [217,"<B"],
    "EVTC_218": [218,"<B"],
    "EventEnd": [219,""],
    "EVTC_220": [220,"<B"],
    "EVTC_221": [221,""],
    "EVTC_222": [222,""],
    "EVTC_223": [223,""],
    "EVTC_224": [224,"<B"],
    "EVTC_225": [225,""],
    "EVTC_226": [226,""],
    "EventEnd2": [227,""],
    "EVTC_228": [228,""],
    "WaitForInstruction": [229,"<BB"],
    "EVTC_230": [230,""],
    "EVTC_231": [231,""],
    "EVTC_232": [232,""],
    "EVTC_233": [233,""],
    "EVTC_234": [234,""],
    "EVTC_235": [235,""],
    "EVTC_236": [236,""],
    "EVTC_237": [237,""],
    "EVTC_238": [238,""],
    "EVTC_239": [239,""],
    "EVTC_240": [240,""],
    "Wait": [241,"<H"],
    "Pad": [242,""]
}

EVTVa2Na=dict([(value[0],[key,value[1]]) for key, value in EVTNa2Va.items()])
